searchData={"items":[{"type":"module","title":"Giraffe","doc":"Documentation for `Giraffe`.","ref":"Giraffe.html"},{"type":"function","title":"Giraffe.hello/0","doc":"Hello world.","ref":"Giraffe.html#hello/0"},{"type":"function","title":"Examples - Giraffe.hello/0","doc":"iex> Giraffe.hello()\n    :world","ref":"Giraffe.html#hello/0-examples"},{"type":"module","title":"Giraffe.Algorithms.BellmanFord","doc":"Implementation of the Bellman-Ford algorithm for finding shortest paths in graphs.","ref":"Giraffe.Algorithms.BellmanFord.html"},{"type":"type","title":"Giraffe.Algorithms.BellmanFord.adjacency_list/0","doc":"","ref":"Giraffe.Algorithms.BellmanFord.html#t:adjacency_list/0"},{"type":"type","title":"Giraffe.Algorithms.BellmanFord.edge/0","doc":"","ref":"Giraffe.Algorithms.BellmanFord.html#t:edge/0"},{"type":"type","title":"Giraffe.Algorithms.BellmanFord.graph_struct/0","doc":"","ref":"Giraffe.Algorithms.BellmanFord.html#t:graph_struct/0"},{"type":"function","title":"Giraffe.Algorithms.BellmanFord.shortest_paths/2","doc":"Finds the shortest paths from a source vertex to all other vertices in the graph.\n\nReturns a map of vertices to their shortest distance from the source.\nIf a negative cycle is detected, returns `{:error, :negative_cycle}`.","ref":"Giraffe.Algorithms.BellmanFord.html#shortest_paths/2"},{"type":"type","title":"Giraffe.Algorithms.BellmanFord.vertex/0","doc":"","ref":"Giraffe.Algorithms.BellmanFord.html#t:vertex/0"},{"type":"module","title":"Giraffe.Algorithms.BronKerbosch","doc":"Implementation of the Bron-Kerbosch algorithm for finding maximal cliques in graphs.","ref":"Giraffe.Algorithms.BronKerbosch.html"},{"type":"function","title":"Giraffe.Algorithms.BronKerbosch.find_cliques/2","doc":"Finds all maximal cliques in a graph using the Bron-Kerbosch algorithm with pivot.","ref":"Giraffe.Algorithms.BronKerbosch.html#find_cliques/2"},{"type":"module","title":"Giraffe.Graph","doc":"Public interface for working with graphs. Delegates to specific implementations\nbased on whether the graph is directed or undirected.","ref":"Giraffe.Graph.html"},{"type":"function","title":"Giraffe.Graph.add_edge/4","doc":"Adds an edge between two vertices with optional weight.","ref":"Giraffe.Graph.html#add_edge/4"},{"type":"function","title":"Examples - Giraffe.Graph.add_edge/4","doc":"iex> graph = Giraffe.Graph.new(type: :directed)\n    iex> Giraffe.Graph.add_edge(graph, :a, :b, 2.5)\n    %Giraffe.Graph{impl: %Giraffe.Graph.Directed{vertices: MapSet.new([:a, :b]), edges: %{a: %{b: 2.5}}}, type: :directed}","ref":"Giraffe.Graph.html#add_edge/4-examples"},{"type":"function","title":"Giraffe.Graph.add_vertex/3","doc":"Adds a new vertex to the graph with optional label.","ref":"Giraffe.Graph.html#add_vertex/3"},{"type":"function","title":"Examples - Giraffe.Graph.add_vertex/3","doc":"iex> graph = Giraffe.Graph.new(type: :directed)\n    iex> Giraffe.Graph.add_vertex(graph, :a, \"vertex A\")\n    %Giraffe.Graph{impl: %Giraffe.Graph.Directed{vertices: MapSet.new([:a]), edges: %{}, labels: %{a: \"vertex A\"}}, type: :directed}","ref":"Giraffe.Graph.html#add_vertex/3-examples"},{"type":"function","title":"Giraffe.Graph.bellman_ford/2","doc":"Finds shortest paths from source vertex using Bellman-Ford algorithm.","ref":"Giraffe.Graph.html#bellman_ford/2"},{"type":"function","title":"Examples - Giraffe.Graph.bellman_ford/2","doc":"iex> graph = Giraffe.Graph.new(type: :directed) |> Giraffe.Graph.add_edge(:a, :b, 1)\n    iex> Giraffe.Graph.bellman_ford(graph, :a)\n    %{a: 0, b: 1}","ref":"Giraffe.Graph.html#bellman_ford/2-examples"},{"type":"function","title":"Giraffe.Graph.dijkstra/3","doc":"Gets the shortest path between two vertices using Dijkstra's algorithm.","ref":"Giraffe.Graph.html#dijkstra/3"},{"type":"function","title":"Examples - Giraffe.Graph.dijkstra/3","doc":"iex> graph = Giraffe.Graph.new(type: :directed) |> Giraffe.Graph.add_edge(:a, :b, 1)\n    iex> Giraffe.Graph.dijkstra(graph, :a, :b)\n    {:ok, [:a, :b], 1}","ref":"Giraffe.Graph.html#dijkstra/3-examples"},{"type":"type","title":"Giraffe.Graph.edge/0","doc":"","ref":"Giraffe.Graph.html#t:edge/0"},{"type":"function","title":"Giraffe.Graph.edges/1","doc":"Returns a list of all edges in the graph.","ref":"Giraffe.Graph.html#edges/1"},{"type":"function","title":"Examples - Giraffe.Graph.edges/1","doc":"iex> graph = Giraffe.Graph.new(type: :directed) |> Giraffe.Graph.add_edge(:a, :b, 1)\n    iex> Giraffe.Graph.edges(graph)\n    [{:a, :b, 1}]","ref":"Giraffe.Graph.html#edges/1-examples"},{"type":"function","title":"Giraffe.Graph.edges/2","doc":"Returns a list of all edges connected to the given vertex.","ref":"Giraffe.Graph.html#edges/2"},{"type":"function","title":"Examples - Giraffe.Graph.edges/2","doc":"iex> graph = Giraffe.Graph.new(type: :directed) |> Giraffe.Graph.add_edge(:a, :b, 1)\n    iex> Giraffe.Graph.edges(graph, :a)\n    [{:a, :b, 1}]","ref":"Giraffe.Graph.html#edges/2-examples"},{"type":"function","title":"Giraffe.Graph.edges/3","doc":"Returns a list of edges between two vertices.","ref":"Giraffe.Graph.html#edges/3"},{"type":"function","title":"Giraffe.Graph.get_label/2","doc":"Gets the label associated with a vertex.","ref":"Giraffe.Graph.html#get_label/2"},{"type":"function","title":"Examples - Giraffe.Graph.get_label/2","doc":"iex> graph = Giraffe.Graph.new(type: :directed) |> Giraffe.Graph.add_vertex(:a, \"label A\")\n    iex> Giraffe.Graph.get_label(graph, :a)\n    \"label A\"","ref":"Giraffe.Graph.html#get_label/2-examples"},{"type":"function","title":"Giraffe.Graph.get_paths/3","doc":"Gets all paths between two vertices.","ref":"Giraffe.Graph.html#get_paths/3"},{"type":"function","title":"Examples - Giraffe.Graph.get_paths/3","doc":"iex> graph = Giraffe.Graph.new(type: :directed) |> Giraffe.Graph.add_edge(:a, :b, 1)\n    iex> Giraffe.Graph.get_paths(graph, :a, :b)\n    [{[:a, :b], 1.0}]","ref":"Giraffe.Graph.html#get_paths/3-examples"},{"type":"function","title":"Giraffe.Graph.get_shortest_path/3","doc":"Gets the shortest path between two vertices.","ref":"Giraffe.Graph.html#get_shortest_path/3"},{"type":"function","title":"Examples - Giraffe.Graph.get_shortest_path/3","doc":"iex> graph = Giraffe.Graph.new(type: :directed) |> Giraffe.Graph.add_edge(:a, :b, 1)\n    iex> Giraffe.Graph.get_shortest_path(graph, :a, :b)\n    {:ok, [:a, :b], 1}","ref":"Giraffe.Graph.html#get_shortest_path/3-examples"},{"type":"function","title":"Giraffe.Graph.has_vertex?/2","doc":"Returns true if the vertex exists in the graph.","ref":"Giraffe.Graph.html#has_vertex?/2"},{"type":"function","title":"Examples - Giraffe.Graph.has_vertex?/2","doc":"iex> graph = Giraffe.Graph.new(type: :directed) |> Giraffe.Graph.add_vertex(:a)\n    iex> Giraffe.Graph.has_vertex?(graph, :a)\n    true","ref":"Giraffe.Graph.html#has_vertex?/2-examples"},{"type":"function","title":"Giraffe.Graph.is_acyclic?/1","doc":"Returns true if the graph is acyclic.","ref":"Giraffe.Graph.html#is_acyclic?/1"},{"type":"function","title":"Examples - Giraffe.Graph.is_acyclic?/1","doc":"iex> graph = Giraffe.Graph.new(type: :directed) |> Giraffe.Graph.add_edge(:a, :b, 1)\n    iex> Giraffe.Graph.is_acyclic?(graph)\n    true","ref":"Giraffe.Graph.html#is_acyclic?/1-examples"},{"type":"function","title":"Giraffe.Graph.is_cyclic?/1","doc":"Returns true if the graph contains cycles.","ref":"Giraffe.Graph.html#is_cyclic?/1"},{"type":"function","title":"Examples - Giraffe.Graph.is_cyclic?/1","doc":"iex> graph = Giraffe.Graph.new(type: :directed) |> Giraffe.Graph.add_edge(:a, :a, 1)\n    iex> Giraffe.Graph.is_cyclic?(graph)\n    true","ref":"Giraffe.Graph.html#is_cyclic?/1-examples"},{"type":"type","title":"Giraffe.Graph.label/0","doc":"","ref":"Giraffe.Graph.html#t:label/0"},{"type":"function","title":"Giraffe.Graph.neighbors/2","doc":"Returns a list of neighboring vertices.","ref":"Giraffe.Graph.html#neighbors/2"},{"type":"function","title":"Examples - Giraffe.Graph.neighbors/2","doc":"iex> graph = Giraffe.Graph.new(type: :directed) |> Giraffe.Graph.add_edge(:a, :b, 1)\n    iex> Giraffe.Graph.neighbors(graph, :a)\n    [:b]","ref":"Giraffe.Graph.html#neighbors/2-examples"},{"type":"function","title":"Giraffe.Graph.new/1","doc":"Creates a new graph.","ref":"Giraffe.Graph.html#new/1"},{"type":"function","title":"Options - Giraffe.Graph.new/1","doc":"* `:type` - The type of graph. Can be `:directed` or `:undirected`. Defaults to `:directed`.","ref":"Giraffe.Graph.html#new/1-options"},{"type":"function","title":"Examples - Giraffe.Graph.new/1","doc":"iex> Giraffe.Graph.new(type: :directed)\n    %Giraffe.Graph{impl: %Giraffe.Graph.Directed{vertices: MapSet.new([]), edges: %{}}, type: :directed}\n\n    iex> Giraffe.Graph.new(type: :undirected)\n    %Giraffe.Graph{impl: %Giraffe.Graph.Undirected{vertices: MapSet.new([]), edges: %{}}, type: :undirected}","ref":"Giraffe.Graph.html#new/1-examples"},{"type":"function","title":"Giraffe.Graph.num_edges/1","doc":"Returns the total number of edges in the graph.","ref":"Giraffe.Graph.html#num_edges/1"},{"type":"function","title":"Examples - Giraffe.Graph.num_edges/1","doc":"iex> graph = Giraffe.Graph.new(type: :directed) |> Giraffe.Graph.add_edge(:a, :b, 1)\n    iex> Giraffe.Graph.num_edges(graph)\n    1","ref":"Giraffe.Graph.html#num_edges/1-examples"},{"type":"function","title":"Giraffe.Graph.num_vertices/1","doc":"Returns the total number of vertices in the graph.","ref":"Giraffe.Graph.html#num_vertices/1"},{"type":"function","title":"Examples - Giraffe.Graph.num_vertices/1","doc":"iex> graph = Giraffe.Graph.new(type: :directed) |> Giraffe.Graph.add_vertex(:a)\n    iex> Giraffe.Graph.num_vertices(graph)\n    1","ref":"Giraffe.Graph.html#num_vertices/1-examples"},{"type":"function","title":"Giraffe.Graph.reachable/2","doc":"Returns a list of vertices reachable from the given vertices.","ref":"Giraffe.Graph.html#reachable/2"},{"type":"function","title":"Examples - Giraffe.Graph.reachable/2","doc":"iex> graph = Giraffe.Graph.new(type: :directed) |> Giraffe.Graph.add_edge(:a, :b, 1)\n    iex> Giraffe.Graph.reachable(graph, [:a])\n    [:a, :b]","ref":"Giraffe.Graph.html#reachable/2-examples"},{"type":"function","title":"Giraffe.Graph.set_label/3","doc":"Sets a label for an existing vertex.","ref":"Giraffe.Graph.html#set_label/3"},{"type":"function","title":"Examples - Giraffe.Graph.set_label/3","doc":"iex> graph = Giraffe.Graph.new(type: :directed) |> Giraffe.Graph.add_vertex(:a)\n    iex> Giraffe.Graph.set_label(graph, :a, \"new label\")\n    %Giraffe.Graph{impl: %Giraffe.Graph.Directed{vertices: MapSet.new([:a]), edges: %{}, labels: %{a: \"new label\"}}, type: :directed}","ref":"Giraffe.Graph.html#set_label/3-examples"},{"type":"type","title":"Giraffe.Graph.t/0","doc":"","ref":"Giraffe.Graph.html#t:t/0"},{"type":"type","title":"Giraffe.Graph.vertex/0","doc":"","ref":"Giraffe.Graph.html#t:vertex/0"},{"type":"function","title":"Giraffe.Graph.vertex_labels/2","doc":"Returns the labels for the given vertex.","ref":"Giraffe.Graph.html#vertex_labels/2"},{"type":"function","title":"Examples - Giraffe.Graph.vertex_labels/2","doc":"iex> graph = Giraffe.Graph.new(type: :directed) |> Giraffe.Graph.add_vertex(:a, [:label])\n    iex> Giraffe.Graph.vertex_labels(graph, :a)\n    [:label]","ref":"Giraffe.Graph.html#vertex_labels/2-examples"},{"type":"function","title":"Giraffe.Graph.vertices/1","doc":"Returns a list of all vertices in the graph.","ref":"Giraffe.Graph.html#vertices/1"},{"type":"function","title":"Examples - Giraffe.Graph.vertices/1","doc":"iex> graph = Giraffe.Graph.new(type: :directed) |> Giraffe.Graph.add_vertex(:a)\n    iex> Giraffe.Graph.vertices(graph)\n    [:a]","ref":"Giraffe.Graph.html#vertices/1-examples"},{"type":"type","title":"Giraffe.Graph.weight/0","doc":"","ref":"Giraffe.Graph.html#t:weight/0"},{"type":"module","title":"Giraffe.Graph.Directed","doc":"Implementation of a directed graph with weighted edges.\nVertices can be any term, and edges have numeric weights.","ref":"Giraffe.Graph.Directed.html"},{"type":"module","title":"Examples - Giraffe.Graph.Directed","doc":"iex> graph = Giraffe.Graph.Directed.new()\n    ...> graph = graph |> Giraffe.Graph.Directed.add_edge(:a, :b, 1)\n    ...> graph |> Giraffe.Graph.Directed.edges()\n    [{:a, :b, 1}]","ref":"Giraffe.Graph.Directed.html#module-examples"},{"type":"function","title":"Giraffe.Graph.Directed.add_edge/4","doc":"Adds a weighted edge between two vertices in the graph.\nThe vertices will be added to the graph if they don't already exist.","ref":"Giraffe.Graph.Directed.html#add_edge/4"},{"type":"function","title":"Examples - Giraffe.Graph.Directed.add_edge/4","doc":"iex> graph = Giraffe.Graph.Directed.new()\n    ...> graph = Giraffe.Graph.Directed.add_edge(graph, :a, :b, 1)\n    ...> Giraffe.Graph.Directed.edges(graph)\n    [{:a, :b, 1}]","ref":"Giraffe.Graph.Directed.html#add_edge/4-examples"},{"type":"function","title":"Giraffe.Graph.Directed.add_vertex/3","doc":"Adds a vertex to the graph with an optional label.","ref":"Giraffe.Graph.Directed.html#add_vertex/3"},{"type":"function","title":"Examples - Giraffe.Graph.Directed.add_vertex/3","doc":"iex> graph = Giraffe.Graph.Directed.new()\n    iex> Giraffe.Graph.Directed.add_vertex(graph, :a, \"vertex A\")\n    %Giraffe.Graph.Directed{vertices: MapSet.new([:a]), edges: %{}, labels: %{a: \"vertex A\"}}","ref":"Giraffe.Graph.Directed.html#add_vertex/3-examples"},{"type":"function","title":"Giraffe.Graph.Directed.bellman_ford/2","doc":"Finds shortest paths using Bellman-Ford algorithm","ref":"Giraffe.Graph.Directed.html#bellman_ford/2"},{"type":"function","title":"Giraffe.Graph.Directed.cliques/1","doc":"Finds all maximal cliques in the graph.\nA clique is a subset of vertices where every vertex is connected to every other vertex.\nOnly considers bidirectional edges.","ref":"Giraffe.Graph.Directed.html#cliques/1"},{"type":"function","title":"Examples - Giraffe.Graph.Directed.cliques/1","doc":"iex> graph = Giraffe.Graph.Directed.new()\n    ...> graph = graph |> Giraffe.Graph.Directed.add_edge(:a, :b, 1)\n    ...> graph = graph |> Giraffe.Graph.Directed.add_edge(:b, :a, 1)\n    ...> Giraffe.Graph.Directed.cliques(graph)\n    [[:a, :b]]","ref":"Giraffe.Graph.Directed.html#cliques/1-examples"},{"type":"function","title":"Giraffe.Graph.Directed.dijkstra/3","doc":"Gets the shortest path between a and b using Dijkstra's algorithm","ref":"Giraffe.Graph.Directed.html#dijkstra/3"},{"type":"type","title":"Giraffe.Graph.Directed.edge/0","doc":"","ref":"Giraffe.Graph.Directed.html#t:edge/0"},{"type":"function","title":"Giraffe.Graph.Directed.edges/1","doc":"Returns a list of all edges in the graph as tuples of {from, to, weight}.","ref":"Giraffe.Graph.Directed.html#edges/1"},{"type":"function","title":"Examples - Giraffe.Graph.Directed.edges/1","doc":"iex> graph = Giraffe.Graph.Directed.new()\n    ...> graph = Giraffe.Graph.Directed.add_edge(graph, :a, :b, 1)\n    ...> Giraffe.Graph.Directed.edges(graph)\n    [{:a, :b, 1}]","ref":"Giraffe.Graph.Directed.html#edges/1-examples"},{"type":"function","title":"Giraffe.Graph.Directed.edges/2","doc":"Returns a list of all edges for a specific vertex.","ref":"Giraffe.Graph.Directed.html#edges/2"},{"type":"function","title":"Examples - Giraffe.Graph.Directed.edges/2","doc":"iex> graph = Giraffe.Graph.Directed.new()\n    ...> graph = Giraffe.Graph.Directed.add_edge(graph, :a, :b, 1)\n    ...> Giraffe.Graph.Directed.edges(graph, :a)\n    [{:a, :b, 1}]","ref":"Giraffe.Graph.Directed.html#edges/2-examples"},{"type":"function","title":"Giraffe.Graph.Directed.get_label/2","doc":"Gets the label associated with a vertex.","ref":"Giraffe.Graph.Directed.html#get_label/2"},{"type":"function","title":"Examples - Giraffe.Graph.Directed.get_label/2","doc":"iex> graph = Giraffe.Graph.Directed.new() |> Giraffe.Graph.Directed.add_vertex(:a, \"vertex A\")\n    iex> Giraffe.Graph.Directed.get_label(graph, :a)\n    \"vertex A\"","ref":"Giraffe.Graph.Directed.html#get_label/2-examples"},{"type":"function","title":"Giraffe.Graph.Directed.get_paths/3","doc":"Finds all possible paths between two vertices.\nReturns a list of tuples containing the path and its total weight.","ref":"Giraffe.Graph.Directed.html#get_paths/3"},{"type":"function","title":"Examples - Giraffe.Graph.Directed.get_paths/3","doc":"iex> graph = Giraffe.Graph.Directed.new()\n    ...> graph = graph |> Giraffe.Graph.Directed.add_edge(:a, :b, 1)\n    ...> Giraffe.Graph.Directed.get_paths(graph, :a, :b)\n    [{[:a, :b], 1.0}]","ref":"Giraffe.Graph.Directed.html#get_paths/3-examples"},{"type":"function","title":"Giraffe.Graph.Directed.get_shortest_path/3","doc":"Finds the shortest path between two vertices using Dijkstra's algorithm.\nReturns {:ok, path, total_weight} if a path exists, or :no_path if no path exists.","ref":"Giraffe.Graph.Directed.html#get_shortest_path/3"},{"type":"function","title":"Examples - Giraffe.Graph.Directed.get_shortest_path/3","doc":"iex> graph = Giraffe.Graph.Directed.new()\n    ...> graph = graph |> Giraffe.Graph.Directed.add_edge(:a, :b, 1)\n    ...> Giraffe.Graph.Directed.get_shortest_path(graph, :a, :b)\n    {:ok, [:a, :b], 1}","ref":"Giraffe.Graph.Directed.html#get_shortest_path/3-examples"},{"type":"function","title":"Giraffe.Graph.Directed.has_vertex?/2","doc":"Returns true if the given vertex exists in the graph.","ref":"Giraffe.Graph.Directed.html#has_vertex?/2"},{"type":"function","title":"Giraffe.Graph.Directed.is_acyclic?/1","doc":"Checks if the graph is acyclic.","ref":"Giraffe.Graph.Directed.html#is_acyclic?/1"},{"type":"function","title":"Examples - Giraffe.Graph.Directed.is_acyclic?/1","doc":"iex> graph = Giraffe.Graph.Directed.new()\n    ...> graph = graph |> Giraffe.Graph.Directed.add_edge(:a, :b, 1)\n    ...> Giraffe.Graph.Directed.is_acyclic?(graph)\n    true","ref":"Giraffe.Graph.Directed.html#is_acyclic?/1-examples"},{"type":"function","title":"Giraffe.Graph.Directed.is_cyclic?/1","doc":"Checks if the graph is cyclic.","ref":"Giraffe.Graph.Directed.html#is_cyclic?/1"},{"type":"function","title":"Examples - Giraffe.Graph.Directed.is_cyclic?/1","doc":"iex> graph = Giraffe.Graph.Directed.new()\n    ...> graph = graph |> Giraffe.Graph.Directed.add_edge(:a, :b, 1)\n    ...> graph = graph |> Giraffe.Graph.Directed.add_edge(:b, :a, 1)\n    ...> Giraffe.Graph.Directed.is_cyclic?(graph)\n    true","ref":"Giraffe.Graph.Directed.html#is_cyclic?/1-examples"},{"type":"function","title":"Giraffe.Graph.Directed.neighbors/2","doc":"Returns a sorted list of all vertices that are neighbors of the given vertex.\nIncludes both incoming and outgoing edges.","ref":"Giraffe.Graph.Directed.html#neighbors/2"},{"type":"function","title":"Examples - Giraffe.Graph.Directed.neighbors/2","doc":"iex> graph = Giraffe.Graph.Directed.new()\n    ...> graph = graph |> Giraffe.Graph.Directed.add_edge(:a, :b, 1)\n    ...> Giraffe.Graph.Directed.neighbors(graph, :a)\n    [:b]","ref":"Giraffe.Graph.Directed.html#neighbors/2-examples"},{"type":"function","title":"Giraffe.Graph.Directed.new/1","doc":"Creates a new empty graph.","ref":"Giraffe.Graph.Directed.html#new/1"},{"type":"function","title":"Examples - Giraffe.Graph.Directed.new/1","doc":"iex> Giraffe.Graph.Directed.new()\n    %Giraffe.Graph.Directed{vertices: MapSet.new(), edges: %{}, labels: %{}}","ref":"Giraffe.Graph.Directed.html#new/1-examples"},{"type":"function","title":"Giraffe.Graph.Directed.num_edges/1","doc":"Returns the number of edges in the graph","ref":"Giraffe.Graph.Directed.html#num_edges/1"},{"type":"function","title":"Giraffe.Graph.Directed.num_vertices/1","doc":"Returns the number of vertices in the graph","ref":"Giraffe.Graph.Directed.html#num_vertices/1"},{"type":"function","title":"Giraffe.Graph.Directed.postorder/1","doc":"Returns vertices in post-order DFS traversal order.","ref":"Giraffe.Graph.Directed.html#postorder/1"},{"type":"function","title":"Examples - Giraffe.Graph.Directed.postorder/1","doc":"iex> graph = Giraffe.Graph.Directed.new()\n    ...> |> Giraffe.Graph.Directed.add_edge(:a, :b, 1)\n    ...> |> Giraffe.Graph.Directed.add_edge(:b, :c, 1)\n    iex> Giraffe.Graph.Directed.postorder(graph)\n    [:c, :b, :a]","ref":"Giraffe.Graph.Directed.html#postorder/1-examples"},{"type":"function","title":"Giraffe.Graph.Directed.reachable/2","doc":"Returns a list of all vertices reachable from the given starting vertices.","ref":"Giraffe.Graph.Directed.html#reachable/2"},{"type":"function","title":"Examples - Giraffe.Graph.Directed.reachable/2","doc":"iex> graph = Giraffe.Graph.Directed.new()\n    ...> |> Giraffe.Graph.Directed.add_edge(:a, :b, 1)\n    ...> |> Giraffe.Graph.Directed.add_edge(:b, :c, 1)\n    iex> Giraffe.Graph.Directed.reachable(graph, [:a])\n    [:a, :b, :c]","ref":"Giraffe.Graph.Directed.html#reachable/2-examples"},{"type":"function","title":"Giraffe.Graph.Directed.set_label/3","doc":"Sets a label for an existing vertex.\nReturns unchanged graph if vertex doesn't exist.","ref":"Giraffe.Graph.Directed.html#set_label/3"},{"type":"function","title":"Examples - Giraffe.Graph.Directed.set_label/3","doc":"iex> graph = Giraffe.Graph.Directed.new() |> Giraffe.Graph.Directed.add_vertex(:a)\n    iex> Giraffe.Graph.Directed.set_label(graph, :a, \"new label\")\n    %Giraffe.Graph.Directed{vertices: MapSet.new([:a]), edges: %{}, labels: %{a: \"new label\"}}","ref":"Giraffe.Graph.Directed.html#set_label/3-examples"},{"type":"function","title":"Giraffe.Graph.Directed.shortest_paths/2","doc":"Finds the shortest paths from a source vertex to all other vertices using the Bellman-Ford algorithm.","ref":"Giraffe.Graph.Directed.html#shortest_paths/2"},{"type":"function","title":"Examples - Giraffe.Graph.Directed.shortest_paths/2","doc":"iex> graph = Giraffe.Graph.Directed.new()\n    ...> graph = graph |> Giraffe.Graph.Directed.add_edge(:a, :b, 1)\n    ...> Giraffe.Graph.Directed.shortest_paths(graph, :a)\n    {:ok, %{a: 0, b: 1}}","ref":"Giraffe.Graph.Directed.html#shortest_paths/2-examples"},{"type":"type","title":"Giraffe.Graph.Directed.t/0","doc":"","ref":"Giraffe.Graph.Directed.html#t:t/0"},{"type":"type","title":"Giraffe.Graph.Directed.vertex/0","doc":"","ref":"Giraffe.Graph.Directed.html#t:vertex/0"},{"type":"function","title":"Giraffe.Graph.Directed.vertex_labels/2","doc":"Returns the label for the given vertex","ref":"Giraffe.Graph.Directed.html#vertex_labels/2"},{"type":"function","title":"Giraffe.Graph.Directed.vertices/1","doc":"Returns a list of all vertices in the graph.","ref":"Giraffe.Graph.Directed.html#vertices/1"},{"type":"function","title":"Examples - Giraffe.Graph.Directed.vertices/1","doc":"iex> graph = Giraffe.Graph.Directed.new() |> Giraffe.Graph.Directed.add_vertex(:a)\n    iex> Giraffe.Graph.Directed.vertices(graph)\n    [:a]","ref":"Giraffe.Graph.Directed.html#vertices/1-examples"},{"type":"type","title":"Giraffe.Graph.Directed.weight/0","doc":"","ref":"Giraffe.Graph.Directed.html#t:weight/0"},{"type":"module","title":"Giraffe.Graph.Undirected","doc":"Implementation of an undirected graph with weighted edges.\nVertices can be any term, and edges have numeric weights.","ref":"Giraffe.Graph.Undirected.html"},{"type":"function","title":"Giraffe.Graph.Undirected.add_edge/4","doc":"Adds an edge between two vertices with the given weight.\nIf the vertices don't exist, they will be added to the graph.","ref":"Giraffe.Graph.Undirected.html#add_edge/4"},{"type":"function","title":"Giraffe.Graph.Undirected.add_vertex/3","doc":"Adds a vertex to the graph with an optional label.","ref":"Giraffe.Graph.Undirected.html#add_vertex/3"},{"type":"function","title":"Examples - Giraffe.Graph.Undirected.add_vertex/3","doc":"iex> graph = Giraffe.Graph.Directed.new()\n    iex> Giraffe.Graph.Directed.add_vertex(graph, :a, \"vertex A\")\n    %Giraffe.Graph.Directed{vertices: MapSet.new([:a]), edges: %{}, labels: %{a: \"vertex A\"}}","ref":"Giraffe.Graph.Undirected.html#add_vertex/3-examples"},{"type":"function","title":"Giraffe.Graph.Undirected.bellman_ford/2","doc":"Finds shortest paths from a source vertex using the Bellman-Ford algorithm.\nReturns nil if a negative cycle is detected.","ref":"Giraffe.Graph.Undirected.html#bellman_ford/2"},{"type":"function","title":"Examples - Giraffe.Graph.Undirected.bellman_ford/2","doc":"iex> graph = Giraffe.Graph.Undirected.new()\n    ...> graph = graph |> Giraffe.Graph.Undirected.add_edge(:a, :b, 1)\n    ...> graph |> Giraffe.Graph.Undirected.bellman_ford(:a)\n    %{a: 0, b: 1}","ref":"Giraffe.Graph.Undirected.html#bellman_ford/2-examples"},{"type":"function","title":"Giraffe.Graph.Undirected.cliques/1","doc":"Detects all maximal cliques in the graph using the Bron-Kerbosch algorithm.","ref":"Giraffe.Graph.Undirected.html#cliques/1"},{"type":"type","title":"Giraffe.Graph.Undirected.edge/0","doc":"","ref":"Giraffe.Graph.Undirected.html#t:edge/0"},{"type":"function","title":"Giraffe.Graph.Undirected.edges/1","doc":"Returns a list of all edges in the graph as tuples of {from, to, weight}.","ref":"Giraffe.Graph.Undirected.html#edges/1"},{"type":"function","title":"Examples - Giraffe.Graph.Undirected.edges/1","doc":"iex> graph = Giraffe.Graph.Undirected.new()\n    ...> graph = Giraffe.Graph.Undirected.add_edge(graph, :a, :b, 1)\n    ...> Giraffe.Graph.Undirected.edges(graph)\n    [{:a, :b, 1}]","ref":"Giraffe.Graph.Undirected.html#edges/1-examples"},{"type":"function","title":"Giraffe.Graph.Undirected.edges/2","doc":"Returns a list of all edges for a specific vertex.","ref":"Giraffe.Graph.Undirected.html#edges/2"},{"type":"function","title":"Examples - Giraffe.Graph.Undirected.edges/2","doc":"iex> graph = Giraffe.Graph.Undirected.new()\n    ...> graph = Giraffe.Graph.Undirected.add_edge(graph, :a, :b, 1)\n    ...> Giraffe.Graph.Undirected.edges(graph, :a)\n    [{:a, :b, 1}]","ref":"Giraffe.Graph.Undirected.html#edges/2-examples"},{"type":"function","title":"Giraffe.Graph.Undirected.get_label/2","doc":"Gets the label associated with a vertex.","ref":"Giraffe.Graph.Undirected.html#get_label/2"},{"type":"function","title":"Examples - Giraffe.Graph.Undirected.get_label/2","doc":"iex> graph = Giraffe.Graph.Directed.new() |> Giraffe.Graph.Directed.add_vertex(:a, \"vertex A\")\n    iex> Giraffe.Graph.Directed.get_label(graph, :a)\n    \"vertex A\"","ref":"Giraffe.Graph.Undirected.html#get_label/2-examples"},{"type":"function","title":"Giraffe.Graph.Undirected.get_paths/3","doc":"Finds all possible paths between two vertices.\nReturns a list of tuples containing the path and its total weight.","ref":"Giraffe.Graph.Undirected.html#get_paths/3"},{"type":"function","title":"Giraffe.Graph.Undirected.get_shortest_path/3","doc":"Finds the shortest path between two vertices using Dijkstra's algorithm.\nReturns {:ok, path, total_weight} if a path exists, :no_path otherwise.","ref":"Giraffe.Graph.Undirected.html#get_shortest_path/3"},{"type":"function","title":"Giraffe.Graph.Undirected.has_vertex?/2","doc":"Returns true if the given vertex exists in the graph.","ref":"Giraffe.Graph.Undirected.html#has_vertex?/2"},{"type":"function","title":"Giraffe.Graph.Undirected.is_acyclic?/1","doc":"Checks if the graph is acyclic (contains no cycles).","ref":"Giraffe.Graph.Undirected.html#is_acyclic?/1"},{"type":"function","title":"Giraffe.Graph.Undirected.is_cyclic?/1","doc":"Checks if the graph contains any cycles.","ref":"Giraffe.Graph.Undirected.html#is_cyclic?/1"},{"type":"function","title":"Giraffe.Graph.Undirected.neighbors/2","doc":"","ref":"Giraffe.Graph.Undirected.html#neighbors/2"},{"type":"function","title":"Giraffe.Graph.Undirected.new/1","doc":"Creates a new empty graph.","ref":"Giraffe.Graph.Undirected.html#new/1"},{"type":"function","title":"Examples - Giraffe.Graph.Undirected.new/1","doc":"iex> Giraffe.Graph.Directed.new()\n    %Giraffe.Graph.Directed{vertices: MapSet.new(), edges: %{}, labels: %{}}","ref":"Giraffe.Graph.Undirected.html#new/1-examples"},{"type":"function","title":"Giraffe.Graph.Undirected.num_edges/1","doc":"Returns the number of edges in the graph","ref":"Giraffe.Graph.Undirected.html#num_edges/1"},{"type":"function","title":"Giraffe.Graph.Undirected.num_vertices/1","doc":"Returns the number of vertices in the graph","ref":"Giraffe.Graph.Undirected.html#num_vertices/1"},{"type":"function","title":"Giraffe.Graph.Undirected.postorder/1","doc":"Returns vertices in post-order DFS traversal order.","ref":"Giraffe.Graph.Undirected.html#postorder/1"},{"type":"function","title":"Examples - Giraffe.Graph.Undirected.postorder/1","doc":"iex> graph = Giraffe.Graph.Directed.new()\n    ...> |> Giraffe.Graph.Directed.add_edge(:a, :b, 1)\n    ...> |> Giraffe.Graph.Directed.add_edge(:b, :c, 1)\n    iex> Giraffe.Graph.Directed.postorder(graph)\n    [:c, :b, :a]","ref":"Giraffe.Graph.Undirected.html#postorder/1-examples"},{"type":"function","title":"Giraffe.Graph.Undirected.reachable/2","doc":"Returns a list of all vertices reachable from the given starting vertices.","ref":"Giraffe.Graph.Undirected.html#reachable/2"},{"type":"function","title":"Examples - Giraffe.Graph.Undirected.reachable/2","doc":"iex> graph = Giraffe.Graph.Directed.new()\n    ...> |> Giraffe.Graph.Directed.add_edge(:a, :b, 1)\n    ...> |> Giraffe.Graph.Directed.add_edge(:b, :c, 1)\n    iex> Giraffe.Graph.Directed.reachable(graph, [:a])\n    [:a, :b, :c]","ref":"Giraffe.Graph.Undirected.html#reachable/2-examples"},{"type":"function","title":"Giraffe.Graph.Undirected.set_label/3","doc":"Sets a label for an existing vertex.\nReturns unchanged graph if vertex doesn't exist.","ref":"Giraffe.Graph.Undirected.html#set_label/3"},{"type":"function","title":"Examples - Giraffe.Graph.Undirected.set_label/3","doc":"iex> graph = Giraffe.Graph.Directed.new() |> Giraffe.Graph.Directed.add_vertex(:a)\n    iex> Giraffe.Graph.Directed.set_label(graph, :a, \"new label\")\n    %Giraffe.Graph.Directed{vertices: MapSet.new([:a]), edges: %{}, labels: %{a: \"new label\"}}","ref":"Giraffe.Graph.Undirected.html#set_label/3-examples"},{"type":"function","title":"Giraffe.Graph.Undirected.shortest_paths/2","doc":"Finds shortest paths using Bellman-Ford algorithm.","ref":"Giraffe.Graph.Undirected.html#shortest_paths/2"},{"type":"type","title":"Giraffe.Graph.Undirected.t/0","doc":"","ref":"Giraffe.Graph.Undirected.html#t:t/0"},{"type":"type","title":"Giraffe.Graph.Undirected.vertex/0","doc":"","ref":"Giraffe.Graph.Undirected.html#t:vertex/0"},{"type":"function","title":"Giraffe.Graph.Undirected.vertex_labels/2","doc":"Returns the label for the given vertex","ref":"Giraffe.Graph.Undirected.html#vertex_labels/2"},{"type":"function","title":"Giraffe.Graph.Undirected.vertices/1","doc":"Returns a list of all vertices in the graph.","ref":"Giraffe.Graph.Undirected.html#vertices/1"},{"type":"function","title":"Examples - Giraffe.Graph.Undirected.vertices/1","doc":"iex> graph = Giraffe.Graph.Directed.new() |> Giraffe.Graph.Directed.add_vertex(:a)\n    iex> Giraffe.Graph.Directed.vertices(graph)\n    [:a]","ref":"Giraffe.Graph.Undirected.html#vertices/1-examples"},{"type":"type","title":"Giraffe.Graph.Undirected.weight/0","doc":"","ref":"Giraffe.Graph.Undirected.html#t:weight/0"},{"type":"module","title":"Giraffe.PriorityQueue","doc":"A Priority Queue implementation using a list-based heap structure.\nLower priority values are dequeued first.","ref":"Giraffe.PriorityQueue.html"},{"type":"function","title":"Giraffe.PriorityQueue.dequeue/1","doc":"Dequeues the item with the lowest priority\nReturns {item, new_queue} or :empty if queue is empty","ref":"Giraffe.PriorityQueue.html#dequeue/1"},{"type":"function","title":"Giraffe.PriorityQueue.empty?/1","doc":"Checks if the queue is empty","ref":"Giraffe.PriorityQueue.html#empty?/1"},{"type":"function","title":"Giraffe.PriorityQueue.enqueue/3","doc":"Enqueues an item with a given priority","ref":"Giraffe.PriorityQueue.html#enqueue/3"},{"type":"function","title":"Giraffe.PriorityQueue.new/0","doc":"Creates a new empty priority queue","ref":"Giraffe.PriorityQueue.html#new/0"},{"type":"function","title":"Giraffe.PriorityQueue.peek/1","doc":"Returns the highest priority item without removing it from the queue\nReturns {:ok, item} or :empty if queue is empty","ref":"Giraffe.PriorityQueue.html#peek/1"},{"type":"function","title":"Giraffe.PriorityQueue.size/1","doc":"Returns the size of the queue","ref":"Giraffe.PriorityQueue.html#size/1"},{"type":"type","title":"Giraffe.PriorityQueue.t/0","doc":"","ref":"Giraffe.PriorityQueue.html#t:t/0"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.36.1"}}